#ifndef _DEFS_H
#define _DEFS_H

#define DISKDEV "DiskImages/Simple"
#define BYTESPERSECT 512

#define MAXOPENFILES 20

#define EDALLOCUNITS 9


#define MAXGROWSIZE 500

#define MAXSECTSPEROP 2880

#define MAXWRITESBEFOREMRFLUSH 500

#define MACDIRSEP ':'

#define VOLNAMELEN 27
#define FINDERINFOLEN 32
#define MAXFNLENGTH 32

#define VOLINFOBLOCK 2
#define VOLBMAP      3

#define NUMBOOTBLOCKS 2
#define NUMVIBBLOCKS  1

#define VALIDVAL 'V'



#define STDFILEFLAGS 0x0
#define STDFILETYPE  0x0
#define STDFILEFINDERINFO "TEXTttxt\x1\x0\x0\x34\x0\x74\x0\x0"
#define STDFILEFINDERINFO2 "\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0"
#define STDFILERESERVED 0x0
#define STDDIRFINDERINFO "\x0\x2e\x0\x8\x0\xea\x1\x9c\x01\x0\x0\x0\x0\x74\x1\x0"
#define STDDIRFINDERINFO2 "\xff\xfb\xff\xdf\x0\x0\x0\x0\x0\x0\x80\x0\x0\x0\x0\x0"
#define STDDIRRESERVE "\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0"
#define STDDIRFLAGS 0x0

#define ICONXPELS 50
#define ICONYPELS 50
#define ICONSHOR  7
#define EXTRAICONROWS 5


#define CRNALLOCUNITS 100




 
void bcopy(void* src, void* dst, int length);
void bzero(void* dest, int length);

#ifdef PMAX

#define BYTE     unsigned char
#define WORD     unsigned short
#define LONGWORD unsigned int

#define SIGNEDLONGWORD signed int

#define reorderword(byteptr) ((((WORD)(*(byteptr)))<<8)           \
                             |(((WORD)(*((byteptr)+1)))))



#define reorderlongword(byteptr)  (                                         \
                                   (((LONGWORD)(*(byteptr)))<<24)         \
                                  |(((LONGWORD)(*((byteptr)+1)))<<16)         \
                                  |(((LONGWORD)(*((byteptr)+2)))<<8)          \
                                  |((LONGWORD)(*((byteptr)+3)))               \
                                  )         

#define reorderwordintobuf(bufstart,startindex,inpstart) \
      t=(BYTE *)&(inpstart);                   \
      (bufstart)[(startindex)]=t[1];            \
      (bufstart)[(startindex)+1]=t[0]            

#define reorderlongwordintobuf(bufstart,startindex,inpstart) \
      t=(BYTE *)&(inpstart);              \
      (bufstart)[(startindex)]=t[3];       \
      (bufstart)[(startindex)+1]=t[2];     \
      (bufstart)[(startindex)+2]=t[1];   \
      (bufstart)[(startindex)+3]=t[0]    


#endif

#ifdef I486

#define BYTE     unsigned char
#define WORD     unsigned short
#define LONGWORD unsigned int

#define SIGNEDLONGWORD signed int

#define reorderword(byteptr) ((((WORD)(*(byteptr)))<<8)           \
                             |(((WORD)(*((byteptr)+1)))))



#define reorderlongword(byteptr)  (                                         \
                                   (((LONGWORD)(*(byteptr)))<<24)         \
                                  |(((LONGWORD)(*((byteptr)+1)))<<16)         \
                                  |(((LONGWORD)(*((byteptr)+2)))<<8)          \
                                  |((LONGWORD)(*((byteptr)+3)))               \
                                  )         

#define reorderwordintobuf(bufstart,startindex,inpstart) \
      t=(BYTE *)&(inpstart);                   \
      (bufstart)[(startindex)]=t[1];            \
      (bufstart)[(startindex)+1]=t[0]            

#define reorderlongwordintobuf(bufstart,startindex,inpstart) \
      t=(BYTE *)&(inpstart);              \
      (bufstart)[(startindex)]=t[3];       \
      (bufstart)[(startindex)+1]=t[2];     \
      (bufstart)[(startindex)+2]=t[1];   \
      (bufstart)[(startindex)+3]=t[0]    

#endif

#ifdef MAC

#define BYTE     unsigned char
#define WORD     unsigned int
#define LONGWORD unsigned long



#define reorderword(byteptr) ((((WORD)(*(byteptr)))<<8)           \
                             |(((WORD)(*((byteptr)+1)))))



#define reorderlongword(byteptr)  (                                         \
                                   (((LONGWORD)(*(byteptr)))<<24)         \
                                  |(((LONGWORD)(*((byteptr)+1)))<<16)         \
                                  |(((LONGWORD)(*((byteptr)+2)))<<8)          \
                                  |((LONGWORD)(*((byteptr)+3)))               \
                                  )         


#define reorderwordintobuf(bufstart,startindex,inpstart) \
      t=(BYTE *)&(inpstart);                   \
      (bufstart)[(startindex)]=t[1];            \
      (bufstart)[(startindex)+1]=t[0]            

#define reorderlongwordintobuf(bufstart,startindex,inpstart) \
      t=(BYTE *)&(inpstart);              \
      (bufstart)[(startindex)]=t[3];       \
      (bufstart)[(startindex)+1]=t[2];     \
      (bufstart)[(startindex)+2]=t[1];   \
      (bufstart)[(startindex)+3]=t[0]    



#endif

#ifdef VFS
/*#define KERNEL 1*/
#endif

#endif /* _DEFS_H */